
#ifndef CRAYONIZER_COMMON_H
#define CRAYONIZER_COMMON_H

#define _GNU_SOURCE 
#include "libUseful-2.0/libUseful.h"
#include <sys/types.h>
#include <glob.h>
#include <regex.h>
#include <signal.h>

#define GLOBAL_CONFIG_FILE "/etc/crayonizer.conf"
#define USER_CONFIG_FILE ".crayonizer.conf"

typedef enum {NONE, BLACK, RED, GREEN, YELLOW, BLUE, MAGENTA, CYAN, WHITE};


//these go in highbytes of 'Crayon->Action->Attribs'
#define FLAG_HIDE			65536
#define FLAG_BOLD			131072
#define FLAG_FAINT		262144
#define FLAG_UNDER		524288
#define FLAG_BLINK		1048576
#define FLAG_INVERSE	2097152
#define FLAG_CAPS			4194304
#define FLAG_LOWERCASE 8388608

#define FLAG_PASSINPUT 1
#define FLAG_RESTORE_XTITLE 2
#define FLAG_DONTCRAYON 4

//these go in 'Crayon->Action->ActType'
typedef enum {ACTION_NONE, ACTION_ECHO, ACTION_SETSTR, ACTION_SETENV, ACTION_BASENAME, ACTION_SEND, ACTION_PLAYSOUND, ACTION_EXEC,  ACTION_PASSTO, ACTION_PASSINPUT, ACTION_SET_XTITLE, ACTION_RESTORE_XTITLE, ACTION_ALTSCREEN, ACTION_NORMSCREEN, ACTION_ARGS, ACTION_XTERM_BGCOLOR, ACTION_XTERM_FGCOLOR, ACTION_RXVT_BGCOLOR, ACTION_RXVT_FGCOLOR, ACTION_BGCOLOR, ACTION_FGCOLOR, ACTION_DONTCRAYON, ACTION_CLEARSCREEN};

#define GOT_SIGTERM 524288
#define GOT_SIGINT 1048576
#define GOT_SIGWINCH 2097152


typedef enum {CRAYON_ACTION, CRAYON_ARGS, CRAYON_LINE, CRAYON_STRING, CRAYON_VALUE, CRAYON_MAPTO, CRAYON_LINEMAPTO, CRAYON_APPEND, CRAYON_PREPEND, CRAYON_EXEC, CRAYON_CMDLINE, CRAYON_PASSINPUT, CONFIG_INCLUDE, CONFIG_KEYPRESS, CRAYON_IF, CRAYON_COMPARATOR};

typedef struct t_crayon TCrayon;

//This structure holds all the information needed to crayon a line
struct t_crayon
{
int Type;
int ActType;
char *Match;
char Op;
float Value;
char *String;
int Attribs;
int ActionCount;
TCrayon *Actions;
}; 

extern char *Version;
extern int GlobalFlags;
extern TCrayon *KeyPresses;
extern int NoOfKeyPresses;


#endif
